﻿using IrController.Model;
using IrController.Repository;
using Microsoft.AspNetCore.Mvc;
using System.Collections.Generic;

namespace IrController.Api.Controllers
{
    [ApiController]
    [Route("api/[controller]/[action]")]
    public class LogController : ControllerBase, ILogRepository
    {
        private readonly ILogRepository _logRepository;
        public LogController(ILogRepository logRepository)
        {
            _logRepository = logRepository;
        }

        /// <summary>
        /// Add log to Errors
        /// </summary>
        /// <param name="error"></param>
        [HttpGet]
        public void AddLog(string error)
        {
            _logRepository.AddLog(error);
        }

        /// <summary>
        /// Get all Errors
        /// </summary>
        /// <returns></returns>
        [HttpGet]
        public List<LogModel> GetLogs()
        {
            return _logRepository.GetLogs();
        }
    }
}
