﻿using Microsoft.OpenApi.Models;
using Swashbuckle.AspNetCore.SwaggerGen;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace IrController.Api.Filters
{
    public class SwashbuckleOperationFilter : IOperationFilter
    {
        /// <summary>
        /// Filtr pro generovani swaggeru do Controller.JmenoMetody
        /// </summary>
        public void Apply(OpenApiOperation operation, OperationFilterContext context)
        {
            if (context == null || operation == null)
                return;

            if (context.ApiDescription.ActionDescriptor is Microsoft.AspNetCore.Mvc.Controllers.ControllerActionDescriptor controllerActionDescriptor)
            {
                operation.OperationId = $"{controllerActionDescriptor.ControllerName}_{controllerActionDescriptor.ActionName}";
            }
        }
    }
}
