﻿using System.Collections.Generic;
using System.ComponentModel.DataAnnotations.Schema;

namespace IrController.DbModel.Db.Model
{
    public class Arduino
    {
        public Arduino()
        {
            Devices = new List<Device>();
        }

        public int Id { get; set; }

        /// <summary>
        /// Name of Arduino for easer management
        /// </summary>
        public string Name { get; set; }

        /// <summary>
        /// Static Ip address of Arduino
        /// </summary>
        public string Ip { get; set; }

        public string Mac { get; set; }

        public string Token { get; set; }


        /// <summary>
        /// All devices connected to Arduino
        /// </summary>
        [InverseProperty("Arduino")]
        public List<Device> Devices { get; set;}
    }
}
