﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Text;

namespace IrController.DbModel.Db.Model
{
    public class DeviceTemplate
    {
        public DeviceTemplate()
        {
            DeviceFunctions = new List<Device_Templates_x_Functions>();
            Devices = new List<Device>();
        }

        [Key]
        public int Id { get; set; }

        /// <summary>
        /// Name of template
        /// </summary>
        /// 
        /// <example>
        /// Simple Light, Color Light, ....
        /// </example>
        public string Name { get; set; }

        /// <summary>
        /// Type of Accessory (homebridge plugin name)
        /// </summary>
        /// 
        /// <example>
        /// HttpPushRgb
        /// </example>
        public string Accessory { get; set; }

        /// <summary>
        /// Service type
        /// </summary>
        /// 
        /// <example>
        /// Light
        /// </example>
        public string Service { get; set; }


        [InverseProperty("DeviceTemplate")]
        public virtual List<Device> Devices { get; set; }

        [InverseProperty("DeviceTemplate")]
        public virtual List<Device_Templates_x_Functions> DeviceFunctions { get; set; }
    }
}
