﻿using System;
using Microsoft.EntityFrameworkCore.Migrations;

namespace IrController.DbModel.Migrations
{
    public partial class init : Migration
    {
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.CreateTable(
                name: "Arduinos",
                columns: table => new
                {
                    Id = table.Column<int>(type: "int", nullable: false)
                        .Annotation("SqlServer:Identity", "1, 1"),
                    Name = table.Column<string>(type: "nvarchar(max)", nullable: true),
                    Ip = table.Column<string>(type: "nvarchar(max)", nullable: true),
                    Mac = table.Column<string>(type: "nvarchar(max)", nullable: true),
                    Token = table.Column<string>(type: "nvarchar(max)", nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Arduinos", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "DeviceCategories",
                columns: table => new
                {
                    Id = table.Column<int>(type: "int", nullable: false)
                        .Annotation("SqlServer:Identity", "1, 1"),
                    Name = table.Column<string>(type: "nvarchar(max)", nullable: true),
                    CodeString = table.Column<string>(type: "nvarchar(max)", nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_DeviceCategories", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "DeviceTemplates",
                columns: table => new
                {
                    Id = table.Column<int>(type: "int", nullable: false)
                        .Annotation("SqlServer:Identity", "1, 1"),
                    Name = table.Column<string>(type: "nvarchar(max)", nullable: true),
                    Accessory = table.Column<string>(type: "nvarchar(max)", nullable: true),
                    Service = table.Column<string>(type: "nvarchar(max)", nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_DeviceTemplates", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "Logs",
                columns: table => new
                {
                    Id = table.Column<int>(type: "int", nullable: false)
                        .Annotation("SqlServer:Identity", "1, 1"),
                    Text = table.Column<string>(type: "nvarchar(max)", nullable: true),
                    CreatedDateTime = table.Column<DateTime>(type: "datetime2", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Logs", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "MissingCodes",
                columns: table => new
                {
                    Id = table.Column<int>(type: "int", nullable: false)
                        .Annotation("SqlServer:Identity", "1, 1"),
                    IrProtocol = table.Column<string>(type: "nvarchar(max)", nullable: true),
                    IrCommand = table.Column<string>(type: "nvarchar(max)", nullable: true),
                    DateTimeCreated = table.Column<DateTime>(type: "datetime2", nullable: false),
                    SAddress = table.Column<string>(type: "nvarchar(max)", nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_MissingCodes", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "Users",
                columns: table => new
                {
                    Id = table.Column<Guid>(type: "uniqueidentifier", nullable: false),
                    Token = table.Column<string>(type: "nvarchar(max)", nullable: true),
                    Username = table.Column<string>(type: "nvarchar(max)", nullable: true),
                    Password = table.Column<string>(type: "nvarchar(max)", nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Users", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "DeviceFunctions",
                columns: table => new
                {
                    Id = table.Column<int>(type: "int", nullable: false)
                        .Annotation("SqlServer:Identity", "1, 1"),
                    Name = table.Column<string>(type: "nvarchar(max)", nullable: true),
                    CodeString = table.Column<string>(type: "nvarchar(max)", nullable: true),
                    DeviceCategoryId = table.Column<int>(type: "int", nullable: false),
                    Url = table.Column<string>(type: "nvarchar(max)", nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_DeviceFunctions", x => x.Id);
                    table.ForeignKey(
                        name: "FK_DeviceFunctions_DeviceCategories_DeviceCategoryId",
                        column: x => x.DeviceCategoryId,
                        principalTable: "DeviceCategories",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "Devices",
                columns: table => new
                {
                    Id = table.Column<int>(type: "int", nullable: false)
                        .Annotation("SqlServer:Identity", "1, 1"),
                    Name = table.Column<string>(type: "nvarchar(max)", nullable: true),
                    MaxBrightnessStep = table.Column<int>(type: "int", nullable: true),
                    ArduinoId = table.Column<int>(type: "int", nullable: true),
                    DeviceTemplateId = table.Column<int>(type: "int", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Devices", x => x.Id);
                    table.ForeignKey(
                        name: "FK_Devices_Arduinos_ArduinoId",
                        column: x => x.ArduinoId,
                        principalTable: "Arduinos",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Restrict);
                    table.ForeignKey(
                        name: "FK_Devices_DeviceTemplates_DeviceTemplateId",
                        column: x => x.DeviceTemplateId,
                        principalTable: "DeviceTemplates",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "Device_Templates_x_Functions",
                columns: table => new
                {
                    Id = table.Column<int>(type: "int", nullable: false)
                        .Annotation("SqlServer:Identity", "1, 1"),
                    DeviceTemplateId = table.Column<int>(type: "int", nullable: false),
                    DeviceFunctionId = table.Column<int>(type: "int", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Device_Templates_x_Functions", x => x.Id);
                    table.ForeignKey(
                        name: "FK_Device_Templates_x_Functions_DeviceFunctions_DeviceFunctionId",
                        column: x => x.DeviceFunctionId,
                        principalTable: "DeviceFunctions",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_Device_Templates_x_Functions_DeviceTemplates_DeviceTemplateId",
                        column: x => x.DeviceTemplateId,
                        principalTable: "DeviceTemplates",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "Codes",
                columns: table => new
                {
                    Id = table.Column<int>(type: "int", nullable: false)
                        .Annotation("SqlServer:Identity", "1, 1"),
                    Name = table.Column<string>(type: "nvarchar(max)", nullable: true),
                    IrProtocol = table.Column<string>(type: "nvarchar(max)", nullable: true),
                    BrightnessUp = table.Column<bool>(type: "bit", nullable: false),
                    ColorValue = table.Column<string>(type: "nvarchar(max)", nullable: true),
                    SAddress = table.Column<string>(type: "nvarchar(max)", nullable: true),
                    IrCommand = table.Column<string>(type: "nvarchar(max)", nullable: true),
                    DeviceId = table.Column<int>(type: "int", nullable: false),
                    Status = table.Column<string>(type: "nvarchar(max)", nullable: true),
                    DeviceFunctionId = table.Column<int>(type: "int", nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Codes", x => x.Id);
                    table.ForeignKey(
                        name: "FK_Codes_DeviceFunctions_DeviceFunctionId",
                        column: x => x.DeviceFunctionId,
                        principalTable: "DeviceFunctions",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Restrict);
                    table.ForeignKey(
                        name: "FK_Codes_Devices_DeviceId",
                        column: x => x.DeviceId,
                        principalTable: "Devices",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.InsertData(
                table: "Arduinos",
                columns: new[] { "Id", "Ip", "Mac", "Name", "Token" },
                values: new object[,]
                {
                    { 1, "192.168.0.41", "AA:AA:AA:AA:AA:AB", "Arduino Test", "Zu6xoYVAHgla03fz" },
                    { 2, "192.168.0.40", "AA:AA:AA:AA:AA:AA", "Arduino Obyvak", "TlpwLwjOBaaQstkf" }
                });

            migrationBuilder.InsertData(
                table: "DeviceCategories",
                columns: new[] { "Id", "CodeString", "Name" },
                values: new object[,]
                {
                    { 1, "switch", "Switch" },
                    { 2, "brightness", "Brightness" },
                    { 3, "color", "Color" }
                });

            migrationBuilder.InsertData(
                table: "DeviceTemplates",
                columns: new[] { "Id", "Accessory", "Name", "Service" },
                values: new object[,]
                {
                    { 1, "HttpPushRgb", "Simple Light", "Light" },
                    { 2, "HttpPushRgb", "Brighness Light", "Light" },
                    { 3, "HttpPushRgb", "Color Light", "Light" }
                });

            migrationBuilder.InsertData(
                table: "DeviceFunctions",
                columns: new[] { "Id", "CodeString", "DeviceCategoryId", "Name", "Url" },
                values: new object[,]
                {
                    { 1, "powerOn", 1, "On", "/Code/SetSwitch?value=1" },
                    { 2, "powerOff", 1, "Off", "/Code/SetSwitch?value=0" },
                    { 3, "url", 2, "Set Brightness", "/Code/SetBrightness?value=%s" },
                    { 4, "url", 3, "Set Color", "/Code/SetColor?value=%s" }
                });

            migrationBuilder.InsertData(
                table: "Devices",
                columns: new[] { "Id", "ArduinoId", "DeviceTemplateId", "MaxBrightnessStep", "Name" },
                values: new object[,]
                {
                    { 1, 1, 1, null, "Hlavni svetlo" },
                    { 2, 2, 3, 4, "Barevne svetlo" }
                });

            migrationBuilder.InsertData(
                table: "Codes",
                columns: new[] { "Id", "BrightnessUp", "ColorValue", "DeviceFunctionId", "DeviceId", "IrCommand", "IrProtocol", "Name", "SAddress", "Status" },
                values: new object[,]
                {
                    { 9, false, "000099", 4, 2, "0x6", "NEC", "Modra", "0xEF00", null },
                    { 7, false, "990000", 4, 2, "0x4", "NEC", "Cervena", "0xEF00", null },
                    { 6, false, null, 3, 2, "0x1", "NEC", "Stmivani -", "0xEF00", null },
                    { 5, true, null, 3, 2, "0x0", "NEC", "Stmivani +", "0xEF00", null },
                    { 4, false, null, 2, 2, "0x2", "NEC", "Zhasnuti", "0xEF00", null },
                    { 3, false, null, 1, 2, "0x3", "NEC", "Rozsviceni", "0xEF00", null },
                    { 2, false, null, 2, 1, "0x2", "NEC", "Zhasnuti", "0xEF00", null },
                    { 1, false, null, 1, 1, "0x3", "NEC", "Rozsviceni", "0xEF00", null },
                    { 8, false, "009900", 4, 2, "0x5", "NEC", "Zelena", "0xEF00", null }
                });

            migrationBuilder.InsertData(
                table: "Device_Templates_x_Functions",
                columns: new[] { "Id", "DeviceFunctionId", "DeviceTemplateId" },
                values: new object[,]
                {
                    { 9, 4, 3 },
                    { 5, 3, 2 },
                    { 7, 2, 3 },
                    { 4, 2, 2 },
                    { 2, 2, 1 },
                    { 6, 1, 3 },
                    { 3, 1, 2 },
                    { 8, 3, 3 },
                    { 1, 1, 1 }
                });

            migrationBuilder.CreateIndex(
                name: "IX_Codes_DeviceFunctionId",
                table: "Codes",
                column: "DeviceFunctionId");

            migrationBuilder.CreateIndex(
                name: "IX_Codes_DeviceId",
                table: "Codes",
                column: "DeviceId");

            migrationBuilder.CreateIndex(
                name: "IX_Device_Templates_x_Functions_DeviceFunctionId",
                table: "Device_Templates_x_Functions",
                column: "DeviceFunctionId");

            migrationBuilder.CreateIndex(
                name: "IX_Device_Templates_x_Functions_DeviceTemplateId",
                table: "Device_Templates_x_Functions",
                column: "DeviceTemplateId");

            migrationBuilder.CreateIndex(
                name: "IX_DeviceFunctions_DeviceCategoryId",
                table: "DeviceFunctions",
                column: "DeviceCategoryId");

            migrationBuilder.CreateIndex(
                name: "IX_Devices_ArduinoId",
                table: "Devices",
                column: "ArduinoId");

            migrationBuilder.CreateIndex(
                name: "IX_Devices_DeviceTemplateId",
                table: "Devices",
                column: "DeviceTemplateId");
        }

        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropTable(
                name: "Codes");

            migrationBuilder.DropTable(
                name: "Device_Templates_x_Functions");

            migrationBuilder.DropTable(
                name: "Logs");

            migrationBuilder.DropTable(
                name: "MissingCodes");

            migrationBuilder.DropTable(
                name: "Users");

            migrationBuilder.DropTable(
                name: "Devices");

            migrationBuilder.DropTable(
                name: "DeviceFunctions");

            migrationBuilder.DropTable(
                name: "Arduinos");

            migrationBuilder.DropTable(
                name: "DeviceTemplates");

            migrationBuilder.DropTable(
                name: "DeviceCategories");
        }
    }
}
