﻿using IrController.DbModel.Db;
using IrController.Model;
using IrController.Repository.Factories;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace IrController.Repository
{
    [Attributes.LoadRepository]
    public class LogRepository : ILogRepository
    {
        private readonly IIrControllerContextFactory _dbContextFactory;
        private const int MAX_LOG = 100;

        public LogRepository(IIrControllerContextFactory dbContextFactory)
        {
            _dbContextFactory = dbContextFactory;
        }

        public void AddLog(string error)
        {
            using (IrControllerContext _db = _dbContextFactory.CreateDbContext())
            {
                try
                {
                    _db.Logs.Add(new DbModel.Db.Model.Log
                    {
                        Text = error,
                        CreatedDateTime = DateTime.Now 
                    });

                    _db.SaveChanges();
                }
                catch (Exception e)
                {

                    return;
                }
               
            }
        }

        public List<LogModel> GetLogs()
        {
            using (IrControllerContext _db = _dbContextFactory.CreateDbContext())
            {
                return _db.Logs.Select(x => new LogModel
                {
                    Text = x.Text,
                    Created = x.CreatedDateTime
                }).TakeLast(MAX_LOG).ToList();
            }
        }
    }
}
