﻿using Newtonsoft.Json;

namespace IrController.Repository.Models.Addons.HttpRgbPushModel
{
    public class Switch
    {
        public Switch(string url)
        {
            status = url;
        }

        /// <summary>
        /// Current status 
        /// return 0 or 1
        /// </summary>
        [JsonProperty("status", NullValueHandling = NullValueHandling.Ignore)]
        public string status { get; set; }

        /// <summary>
        /// URL of API to turn on light
        /// </summary>
        [JsonProperty("powerOn", NullValueHandling = NullValueHandling.Ignore)]
        public string powerOn { get; set; }

        /// <summary>
        /// URL of API to turn off light
        /// </summary>
        [JsonProperty("powerOff", NullValueHandling = NullValueHandling.Ignore)]
        public string powerOff { get; set; }
    }

    public class Brightness
    {
        public Brightness(string url)
        {
            status = url;
        }
        /// <summary>
        /// Current status
        /// </summary>
        [JsonProperty("status", NullValueHandling = NullValueHandling.Ignore)]
        public string status { get; set; }

        /// <summary>
        /// URL of API to set brightness (0-100)
        /// </summary>
        [JsonProperty("url", NullValueHandling = NullValueHandling.Ignore)]
        public string url { get; set; }
    }

    public class Color
    {
        public Color(string url)
        {
            status = url;
        }

        /// <summary>
        /// Current status
        /// </summary>
        [JsonProperty("status", NullValueHandling = NullValueHandling.Ignore)]
        public string status { get; set; }

        /// <summary>
        /// URL of API to set 
        /// </summary>
        [JsonProperty("url", NullValueHandling = NullValueHandling.Ignore)]
        public string url { get; set; }
    }

    public class Accessory
    {
        /// <summary>
        /// Plugin used
        /// </summary>
        [JsonProperty("accessory")]
        public string AccessoryString = "HttpPushRgb";

        /// <summary>
        /// Name of device
        /// </summary>
        [JsonProperty("name")]
        public string Name { get; set; }

        /// <summary>
        /// Switch/Light
        /// </summary>
        [JsonProperty("service")]
        public string Service = "Light";

        /// <summary>
        /// Maximum time to response
        /// </summary>
        [JsonProperty("timeout", NullValueHandling = NullValueHandling.Ignore)]
        public int timeout = 3000;

        /// <summary>
        /// Turn on/off device
        /// </summary>
        [JsonProperty("switch", NullValueHandling = NullValueHandling.Ignore)]
        public Switch Switch { get; set; }

        /// <summary>
        /// Brigtness of light
        /// Can be null
        /// </summary>
        [JsonProperty("brightness", NullValueHandling = NullValueHandling.Ignore)]
        public Brightness Brightness { get; set; }

        /// <summary>
        /// Color of light
        /// Can be null
        /// </summary>
        [JsonProperty("color", NullValueHandling = NullValueHandling.Ignore)]
        public Color Color { get; set; }
    }
}
